package com.gxzc.zen.persistence

import com.baomidou.mybatisplus.annotations.TableField
import com.baomidou.mybatisplus.annotations.TableId
import com.baomidou.mybatisplus.enums.IdType
import com.fasterxml.jackson.databind.annotation.JsonSerialize
import com.fasterxml.jackson.databind.ser.std.ToStringSerializer
import java.io.Serializable
import java.util.*

/**
 * Created by mgr on 2018/1/23.
 */
abstract class ZenBaseModel : Serializable {
    @JsonSerialize(using = ToStringSerializer::class)
    @TableId(type = IdType.ID_WORKER)
    var id: Long? = null
    var createBy: String? = null
    var createTime: Date? = null
    var updateBy: String? = null
    var updateTime: Date? = null
    var remark: String? = null
    var enable: Int? = null

    @TableField(exist = false)
    var map: Map<String, Any?>? = null

    open fun preHandle() {}
}